{- $Id: test.hs,v 1.1.2.13 2009/02/20 18:00:05 orlov Exp $ -}
{- vim: set syntax=haskell expandtab tabstop=4: -}

module Main (
 main, test
) where

import Prelude
import List
import Parser
import System
import PPT
import XSG

usage = "Usage: xsg.exe [xsg-file] <start-point> ..."
file = "test.xsg"

main = do strs <- getArgs
          let f:ss = if ".xsg" `elem` (tails $ strs !! 0) then strs else file:strs
              run str = str++":\n"++(myShow $ Parser.eval f str)++"\n"
              out = if (length strs == 0) then usage++"\n" else concatMap run ss
          putStr out

test = putStr . myShow . Parser.eval file
